<script lang="ts">
import { State, PortalNode } from './portal';

export default defineComponent({
  name: 'PortalManager',
  setup(props, { expose }) {
    const state = reactive<State>({
      portals: [],
    });

    const mount = (key: number, children: PortalNode) => {
      state.portals.push({ key, children });
    };
    const update = (key: number, children: PortalNode) => {
      state.portals = state.portals.map((item) => {
        if (item.key === key) {
          return { ...item, children };
        }
        return item;
      });
    };

    const unmount = (key: number) => {
      state.portals = state.portals.filter((item) => item.key !== key);
    };

    expose({
      mount,
      update,
      unmount,
    });

    return () => {
      return h(
        'div',
        null,
        state.portals.map((item) => {
          return h('div', { key: item.key }, [item.children]);
        })
      );
    };
  },
});
</script>
